searchData={"items":[{"type":"module","title":"Exzeitable","doc":"# Exzeitable. Check README for usage instructions.","ref":"Exzeitable.html"},{"type":"macro","title":"Exzeitable.__using__/1","doc":"Expands into the gigantic monstrosity that is Exzeitable","ref":"Exzeitable.html#__using__/1"},{"type":"module","title":"Exzeitable.Database","doc":"Database interactions","ref":"Exzeitable.Database.html"},{"type":"function","title":"Exzeitable.Database.get_record_count/1","doc":"I want to just do a select: count(c.id)","ref":"Exzeitable.Database.html#get_record_count/1"},{"type":"function","title":"Exzeitable.Database.get_records/1","doc":"Get the data using query","ref":"Exzeitable.Database.html#get_records/1"},{"type":"function","title":"Exzeitable.Database.prefix_search/1","doc":"We only want letters to avoid SQL injection attacks","ref":"Exzeitable.Database.html#prefix_search/1"},{"type":"function","title":"Exzeitable.Database.tsvector_string/1","doc":"Generates the magic SQL fragment that performs search dynamically.\n  Searches across columns that are searchable. Replaces nulls with a space.\n  Created outside macro to bypass ecto restrictions","ref":"Exzeitable.Database.html#tsvector_string/1"},{"type":"module","title":"Exzeitable.HTML","doc":"For building the HTML tags themselves, check CSS.md for information on applying CSS classes.","ref":"Exzeitable.HTML.html"},{"type":"function","title":"Exzeitable.HTML.build/1","doc":"Root function for building the HTML table","ref":"Exzeitable.HTML.html#build/1"},{"type":"function","title":"Exzeitable.HTML.class/2","doc":"Appends additional classes onto the default class if user defined them in config","ref":"Exzeitable.HTML.html#class/2"},{"type":"module","title":"Exzeitable.HTML.ActionButton","doc":"For the actions buttons such as :new, :edit etc, as well as custom buttons.\n\nCustom buttons can be added to the list in :action_buttons","ref":"Exzeitable.HTML.ActionButton.html"},{"type":"module","title":"Example - Exzeitable.HTML.ActionButton","doc":"```elixir\n  action_buttons: [:new, :edit, :super_cool_custom_action]\n```\n\nYou can then define the function called for that action in the module where the table is defined.\nDon't forget to add your csrf_token.\n\n```elixir\n  def super_cool_custom_action(socket, item, csrf_token) do\n    link \"SUPER AWESOME\", to: Routes.super_cool_path(socket, :custom_action, item), \"data-confirm\": \"Are you sure?\", csrf_token: csrf_token\n  end\n```","ref":"Exzeitable.HTML.ActionButton.html#module-example"},{"type":"function","title":"Exzeitable.HTML.ActionButton.build/2","doc":"Builds an individual button, takes an atom representing the action, and the assigns map","ref":"Exzeitable.HTML.ActionButton.html#build/2"},{"type":"function","title":"Exzeitable.HTML.ActionButton.parent_for/2","doc":"Gets the parent that the nested resource belongs to","ref":"Exzeitable.HTML.ActionButton.html#parent_for/2"},{"type":"type","title":"Exzeitable.HTML.ActionButton.action/0","doc":"Controller action","ref":"Exzeitable.HTML.ActionButton.html#t:action/0"},{"type":"type","title":"Exzeitable.HTML.ActionButton.assigns/0","doc":"","ref":"Exzeitable.HTML.ActionButton.html#t:assigns/0"},{"type":"module","title":"Exzeitable.HTML.Filter","doc":"Filtering data","ref":"Exzeitable.HTML.Filter.html"},{"type":"function","title":"Exzeitable.HTML.Filter.fields_where/2","doc":"All fields where a key value is true","ref":"Exzeitable.HTML.Filter.html#fields_where/2"},{"type":"function","title":"Exzeitable.HTML.Filter.fields_where_not/2","doc":"All fields where a key value is false","ref":"Exzeitable.HTML.Filter.html#fields_where_not/2"},{"type":"module","title":"Exzeitable.HTML.Format","doc":"Formatting text","ref":"Exzeitable.HTML.Format.html"},{"type":"function","title":"Exzeitable.HTML.Format.field/3","doc":"If function: true, will pass the entry to the function of the same name as the entry\nElse just output the field\nThis function is tested but coveralls will not register it.","ref":"Exzeitable.HTML.Format.html#field/3"},{"type":"function","title":"Exzeitable.HTML.Format.format_field/1","doc":"The default formatter","ref":"Exzeitable.HTML.Format.html#format_field/1"},{"type":"function","title":"Exzeitable.HTML.Format.header/2","doc":"Will output the user supplied label or fall back on the atom","ref":"Exzeitable.HTML.Format.html#header/2"},{"type":"module","title":"Exzeitable.HTML.Helpers","doc":"Helpers that are needed across multiple modules in the HTML context","ref":"Exzeitable.HTML.Helpers.html"},{"type":"function","title":"Exzeitable.HTML.Helpers.tag/3","doc":"Replacement for content_tag to make it easier to pipe HTML chunks into each other","ref":"Exzeitable.HTML.Helpers.html#tag/3"},{"type":"module","title":"Exzeitable.HTML.Pagination","doc":"For building out the pagination buttons above and below the table","ref":"Exzeitable.HTML.Pagination.html"},{"type":"function","title":"Exzeitable.HTML.Pagination.build/1","doc":"Builds the pagination selector with page numbers, next and back etc.","ref":"Exzeitable.HTML.Pagination.html#build/1"},{"type":"function","title":"Exzeitable.HTML.Pagination.filter_pages/2","doc":"Selects the page buttons we need for pagination","ref":"Exzeitable.HTML.Pagination.html#filter_pages/2"},{"type":"function","title":"Exzeitable.HTML.Pagination.page_count/1","doc":"A partial page is still a page.","ref":"Exzeitable.HTML.Pagination.html#page_count/1"},{"type":"type","title":"Exzeitable.HTML.Pagination.name/0","doc":"","ref":"Exzeitable.HTML.Pagination.html#t:name/0"},{"type":"type","title":"Exzeitable.HTML.Pagination.page/0","doc":"","ref":"Exzeitable.HTML.Pagination.html#t:page/0"},{"type":"type","title":"Exzeitable.HTML.Pagination.pages/0","doc":"","ref":"Exzeitable.HTML.Pagination.html#t:pages/0"},{"type":"module","title":"Exzeitable.HTML.Search","doc":"Build the search field part of the HTML","ref":"Exzeitable.HTML.Search.html"},{"type":"function","title":"Exzeitable.HTML.Search.build/1","doc":"Returns the HTML search form","ref":"Exzeitable.HTML.Search.html#build/1"},{"type":"module","title":"Exzeitable.HTML.ShowButton","doc":"Show buttons and the buttons that toggle their visibility","ref":"Exzeitable.HTML.ShowButton.html"},{"type":"function","title":"Exzeitable.HTML.ShowButton.build_show_button/2","doc":"Returns HTML for the show column button","ref":"Exzeitable.HTML.ShowButton.html#build_show_button/2"},{"type":"function","title":"Exzeitable.HTML.ShowButton.build_show_hide_fields_button/1","doc":"Button for showing and hiding the buttons that show/hide fields","ref":"Exzeitable.HTML.ShowButton.html#build_show_hide_fields_button/1"},{"type":"function","title":"Exzeitable.HTML.ShowButton.show_buttons/1","doc":"Returns HTML for all the show column buttons that should be visible","ref":"Exzeitable.HTML.ShowButton.html#show_buttons/1"},{"type":"module","title":"Exzeitable.HTML.Table","doc":"Builds the table part of the HTML","ref":"Exzeitable.HTML.Table.html"},{"type":"function","title":"Exzeitable.HTML.Table.build/1","doc":"Output the table as HTML","ref":"Exzeitable.HTML.Table.html#build/1"},{"type":"module","title":"Exzeitable.Params","doc":"Gets default parameters, replaces with module opts and then with the function opts.\n\nValidates that parameters are valid.","ref":"Exzeitable.Params.html"},{"type":"function","title":"Exzeitable.Params.new/3","doc":"Creates a new params struct, holds state for liveview","ref":"Exzeitable.Params.html#new/3"},{"type":"function","title":"Exzeitable.Params.set_fields/1","doc":"Gets fields from options and merges it into the defaults","ref":"Exzeitable.Params.html#set_fields/1"},{"type":"type","title":"Exzeitable.Params.column/0","doc":"","ref":"Exzeitable.Params.html#t:column/0"},{"type":"type","title":"Exzeitable.Params.function_name/0","doc":"","ref":"Exzeitable.Params.html#t:function_name/0"},{"type":"type","title":"Exzeitable.Params.t/0","doc":"","ref":"Exzeitable.Params.html#t:t/0"},{"type":"module","title":"Exzeitable.Params.Validations","doc":"Using these instead of Keyword.fetch! to provide nice easily resolvable errors.","ref":"Exzeitable.Params.Validations.html"},{"type":"function","title":"Exzeitable.Params.Validations.paired_options/1","doc":"If you have parent then you need belongs_to, and vice versa.","ref":"Exzeitable.Params.Validations.html#paired_options/1"},{"type":"function","title":"Exzeitable.Params.Validations.required_keys_present/2","doc":"Raises if any of the required keys are not present","ref":"Exzeitable.Params.Validations.html#required_keys_present/2"},{"type":"behaviour","title":"Exzeitable.Text","doc":"Defines the behaviour for, and access to, text for the exzeitable interface.\n\nDefault text is in Exzeitable.Text.Default","ref":"Exzeitable.Text.html"},{"type":"callback","title":"Exzeitable.Text.actions/1","doc":"","ref":"Exzeitable.Text.html#c:actions/1"},{"type":"callback","title":"Exzeitable.Text.confirm_action/1","doc":"","ref":"Exzeitable.Text.html#c:confirm_action/1"},{"type":"callback","title":"Exzeitable.Text.delete/1","doc":"","ref":"Exzeitable.Text.html#c:delete/1"},{"type":"callback","title":"Exzeitable.Text.edit/1","doc":"","ref":"Exzeitable.Text.html#c:edit/1"},{"type":"callback","title":"Exzeitable.Text.hide/1","doc":"","ref":"Exzeitable.Text.html#c:hide/1"},{"type":"callback","title":"Exzeitable.Text.hide_field_buttons/1","doc":"","ref":"Exzeitable.Text.html#c:hide_field_buttons/1"},{"type":"callback","title":"Exzeitable.Text.new/1","doc":"","ref":"Exzeitable.Text.html#c:new/1"},{"type":"callback","title":"Exzeitable.Text.next/1","doc":"","ref":"Exzeitable.Text.html#c:next/1"},{"type":"callback","title":"Exzeitable.Text.nothing_found/1","doc":"","ref":"Exzeitable.Text.html#c:nothing_found/1"},{"type":"callback","title":"Exzeitable.Text.previous/1","doc":"","ref":"Exzeitable.Text.html#c:previous/1"},{"type":"callback","title":"Exzeitable.Text.search/1","doc":"","ref":"Exzeitable.Text.html#c:search/1"},{"type":"callback","title":"Exzeitable.Text.show/1","doc":"","ref":"Exzeitable.Text.html#c:show/1"},{"type":"callback","title":"Exzeitable.Text.show_field/2","doc":"","ref":"Exzeitable.Text.html#c:show_field/2"},{"type":"callback","title":"Exzeitable.Text.show_field_buttons/1","doc":"","ref":"Exzeitable.Text.html#c:show_field_buttons/1"},{"type":"callback","title":"Exzeitable.Text.sort/1","doc":"","ref":"Exzeitable.Text.html#c:sort/1"},{"type":"function","title":"Exzeitable.Text.text/2","doc":"Call the text function with assigns","ref":"Exzeitable.Text.html#text/2"},{"type":"function","title":"Exzeitable.Text.text/3","doc":"Call the text function with assigns and an extra parameter","ref":"Exzeitable.Text.html#text/3"},{"type":"module","title":"Exzeitable.Text.Default","doc":"Default text for the Exzeitable HTML interface","ref":"Exzeitable.Text.Default.html"},{"type":"task","title":"mix exzeitable.gen.migration","doc":"Generates a migration file adding the pg_trgm extension to postgres.\n\nThe repository must be set under `:ecto_repos` in the\ncurrent app configuration or given via the `-r` option.","ref":"Mix.Tasks.Exzeitable.Gen.Migration.html"},{"type":"task","title":"Example - mix exzeitable.gen.migration","doc":"$ mix exzeitable.gen.migration\n    $ mix exzeitable.gen.migration -r Custom.Repo\n\nBy default, the migration will be generated to the\n\"priv/YOUR_REPO/migrations\" directory of the current application\nbut it can be configured to be any subdirectory of `priv` by\nspecifying the `:priv` key under the repository configuration.\n\nThis generator will automatically open the generated file if\nyou have `ECTO_EDITOR` set in your environment variable.","ref":"Mix.Tasks.Exzeitable.Gen.Migration.html#module-example"},{"type":"task","title":"Command line options - mix exzeitable.gen.migration","doc":"* `-r`, `--repo` - the repo to generate migration for\n  * `--no-compile` - does not compile applications before running\n  * `--no-deps-check` - does not check dependencies before running\n  * `--migrations-path` - the path to run the migrations from, defaults to `priv/repo/migrations`","ref":"Mix.Tasks.Exzeitable.Gen.Migration.html#module-command-line-options"},{"type":"task","title":"Configuration - mix exzeitable.gen.migration","doc":"If the current app configuration specifies a custom migration module\nthe generated migration code will use that rather than the default\n`Ecto.Migration`:\n\n    config :ecto_sql, migration_module: MyApplication.CustomMigrationModule","ref":"Mix.Tasks.Exzeitable.Gen.Migration.html#module-configuration"},{"type":"module","title":"TestWeb","doc":"The entrypoint for defining your web interface, such\nas controllers, views, channels and so on.\n\nThis can be used in your application as:\n\n    use TestWeb, :controller\n    use TestWeb, :view\n\nThe definitions below will be executed for every view,\ncontroller, etc, so keep them short and clean, focused\non imports, uses and aliases.\n\nDo NOT define functions inside the quoted expressions\nbelow. Instead, define any helper function in modules\nand import those modules here.","ref":"TestWeb.html"},{"type":"macro","title":"TestWeb.__using__/1","doc":"When used, dispatch to the appropriate controller/view/etc.","ref":"TestWeb.html#__using__/1"},{"type":"function","title":"TestWeb.channel/0","doc":"","ref":"TestWeb.html#channel/0"},{"type":"function","title":"TestWeb.controller/0","doc":"","ref":"TestWeb.html#controller/0"},{"type":"function","title":"TestWeb.router/0","doc":"","ref":"TestWeb.html#router/0"},{"type":"function","title":"TestWeb.view/0","doc":"","ref":"TestWeb.html#view/0"},{"type":"module","title":"TestWeb.BeitrageController","doc":"","ref":"TestWeb.BeitrageController.html"},{"type":"function","title":"TestWeb.BeitrageController.create/2","doc":"","ref":"TestWeb.BeitrageController.html#create/2"},{"type":"function","title":"TestWeb.BeitrageController.delete/2","doc":"","ref":"TestWeb.BeitrageController.html#delete/2"},{"type":"function","title":"TestWeb.BeitrageController.edit/2","doc":"","ref":"TestWeb.BeitrageController.html#edit/2"},{"type":"function","title":"TestWeb.BeitrageController.index/2","doc":"","ref":"TestWeb.BeitrageController.html#index/2"},{"type":"function","title":"TestWeb.BeitrageController.new/2","doc":"","ref":"TestWeb.BeitrageController.html#new/2"},{"type":"function","title":"TestWeb.BeitrageController.show/2","doc":"","ref":"TestWeb.BeitrageController.html#show/2"},{"type":"function","title":"TestWeb.BeitrageController.update/2","doc":"","ref":"TestWeb.BeitrageController.html#update/2"},{"type":"behaviour","title":"TestWeb.BeitrageTable","doc":"Users post table in German","ref":"TestWeb.BeitrageTable.html"},{"type":"function","title":"TestWeb.BeitrageTable.build_table/1","doc":"Convenience helper so LiveView doesn't have to be called directly","ref":"TestWeb.BeitrageTable.html#build_table/1"},{"type":"function","title":"Example - TestWeb.BeitrageTable.build_table/1","doc":"```\n<%= YourAppWeb.Live.Site.live_table(@conn, query: @query) %>\n```","ref":"TestWeb.BeitrageTable.html#build_table/1-example"},{"type":"function","title":"TestWeb.BeitrageTable.do_search/2","doc":"","ref":"TestWeb.BeitrageTable.html#do_search/2"},{"type":"function","title":"TestWeb.BeitrageTable.handle_event/3","doc":"Typing into the search box... searches. Crazy, right?","ref":"TestWeb.BeitrageTable.html#handle_event/3"},{"type":"function","title":"TestWeb.BeitrageTable.handle_info/2","doc":"Refresh periodically grabs new records from the database","ref":"TestWeb.BeitrageTable.html#handle_info/2"},{"type":"function","title":"TestWeb.BeitrageTable.live_table/2","doc":"","ref":"TestWeb.BeitrageTable.html#live_table/2"},{"type":"function","title":"TestWeb.BeitrageTable.mount/3","doc":"Initial setup on page load","ref":"TestWeb.BeitrageTable.html#mount/3"},{"type":"function","title":"TestWeb.BeitrageTable.render/1","doc":"","ref":"TestWeb.BeitrageTable.html#render/1"},{"type":"callback","title":"TestWeb.BeitrageTable.render/1","doc":"","ref":"TestWeb.BeitrageTable.html#c:render/1"},{"type":"type","title":"TestWeb.BeitrageTable.socket/0","doc":"","ref":"TestWeb.BeitrageTable.html#t:socket/0"},{"type":"module","title":"TestWeb.ErrorHelpers","doc":"Conveniences for translating and building error messages.","ref":"TestWeb.ErrorHelpers.html"},{"type":"function","title":"TestWeb.ErrorHelpers.error_tag/2","doc":"Generates tag for inlined form input errors.","ref":"TestWeb.ErrorHelpers.html#error_tag/2"},{"type":"function","title":"TestWeb.ErrorHelpers.translate_error/1","doc":"Translates an error message using gettext.","ref":"TestWeb.ErrorHelpers.html#translate_error/1"},{"type":"module","title":"TestWeb.GermanText","doc":"Custom text for the Exzeitable HTML interface","ref":"TestWeb.GermanText.html"},{"type":"module","title":"TestWeb.Gettext","doc":"A module providing Internationalization with a gettext-based API.\n\nBy using [Gettext](https://hexdocs.pm/gettext),\nyour module gains a set of macros for translations, for example:\n\n    import TestWeb.Gettext\n\n    # Simple translation\n    gettext(\"Here is the string to translate\")\n\n    # Plural translation\n    ngettext(\"Here is the string to translate\",\n             \"Here are the strings to translate\",\n             3)\n\n    # Domain-based translation\n    dgettext(\"errors\", \"Here is the error message to translate\")\n\nSee the [Gettext Docs](https://hexdocs.pm/gettext) for detailed usage.","ref":"TestWeb.Gettext.html"},{"type":"function","title":"TestWeb.Gettext.handle_missing_bindings/2","doc":"","ref":"TestWeb.Gettext.html#handle_missing_bindings/2"},{"type":"function","title":"TestWeb.Gettext.handle_missing_plural_translation/7","doc":"","ref":"TestWeb.Gettext.html#handle_missing_plural_translation/7"},{"type":"function","title":"TestWeb.Gettext.handle_missing_translation/5","doc":"","ref":"TestWeb.Gettext.html#handle_missing_translation/5"},{"type":"module","title":"TestWeb.PageController","doc":"","ref":"TestWeb.PageController.html"},{"type":"function","title":"TestWeb.PageController.index/2","doc":"","ref":"TestWeb.PageController.html#index/2"},{"type":"type","title":"TestWeb.PageController.conn/0","doc":"","ref":"TestWeb.PageController.html#t:conn/0"},{"type":"module","title":"TestWeb.PostController","doc":"","ref":"TestWeb.PostController.html"},{"type":"function","title":"TestWeb.PostController.create/2","doc":"","ref":"TestWeb.PostController.html#create/2"},{"type":"function","title":"TestWeb.PostController.delete/2","doc":"","ref":"TestWeb.PostController.html#delete/2"},{"type":"function","title":"TestWeb.PostController.disable_hide/2","doc":"","ref":"TestWeb.PostController.html#disable_hide/2"},{"type":"function","title":"TestWeb.PostController.edit/2","doc":"","ref":"TestWeb.PostController.html#edit/2"},{"type":"function","title":"TestWeb.PostController.index/2","doc":"","ref":"TestWeb.PostController.html#index/2"},{"type":"function","title":"TestWeb.PostController.new/2","doc":"","ref":"TestWeb.PostController.html#new/2"},{"type":"function","title":"TestWeb.PostController.no_action_buttons/2","doc":"","ref":"TestWeb.PostController.html#no_action_buttons/2"},{"type":"function","title":"TestWeb.PostController.no_pagination/2","doc":"","ref":"TestWeb.PostController.html#no_pagination/2"},{"type":"function","title":"TestWeb.PostController.show/2","doc":"","ref":"TestWeb.PostController.html#show/2"},{"type":"function","title":"TestWeb.PostController.update/2","doc":"","ref":"TestWeb.PostController.html#update/2"},{"type":"behaviour","title":"TestWeb.PostTable","doc":"Users post table","ref":"TestWeb.PostTable.html"},{"type":"function","title":"TestWeb.PostTable.build_table/1","doc":"Convenience helper so LiveView doesn't have to be called directly","ref":"TestWeb.PostTable.html#build_table/1"},{"type":"function","title":"Example - TestWeb.PostTable.build_table/1","doc":"```\n<%= YourAppWeb.Live.Site.live_table(@conn, query: @query) %>\n```","ref":"TestWeb.PostTable.html#build_table/1-example"},{"type":"function","title":"TestWeb.PostTable.custom_button/3","doc":"","ref":"TestWeb.PostTable.html#custom_button/3"},{"type":"function","title":"TestWeb.PostTable.do_search/2","doc":"","ref":"TestWeb.PostTable.html#do_search/2"},{"type":"function","title":"TestWeb.PostTable.handle_event/3","doc":"Typing into the search box... searches. Crazy, right?","ref":"TestWeb.PostTable.html#handle_event/3"},{"type":"function","title":"TestWeb.PostTable.handle_info/2","doc":"Refresh periodically grabs new records from the database","ref":"TestWeb.PostTable.html#handle_info/2"},{"type":"function","title":"TestWeb.PostTable.live_table/2","doc":"","ref":"TestWeb.PostTable.html#live_table/2"},{"type":"function","title":"TestWeb.PostTable.mount/3","doc":"Initial setup on page load","ref":"TestWeb.PostTable.html#mount/3"},{"type":"function","title":"TestWeb.PostTable.render/1","doc":"","ref":"TestWeb.PostTable.html#render/1"},{"type":"callback","title":"TestWeb.PostTable.render/1","doc":"","ref":"TestWeb.PostTable.html#c:render/1"},{"type":"type","title":"TestWeb.PostTable.socket/0","doc":"","ref":"TestWeb.PostTable.html#t:socket/0"},{"type":"module","title":"TestWeb.UserController","doc":"","ref":"TestWeb.UserController.html"},{"type":"function","title":"TestWeb.UserController.create/2","doc":"","ref":"TestWeb.UserController.html#create/2"},{"type":"function","title":"TestWeb.UserController.delete/2","doc":"","ref":"TestWeb.UserController.html#delete/2"},{"type":"function","title":"TestWeb.UserController.edit/2","doc":"","ref":"TestWeb.UserController.html#edit/2"},{"type":"function","title":"TestWeb.UserController.formatted_index/2","doc":"","ref":"TestWeb.UserController.html#formatted_index/2"},{"type":"function","title":"TestWeb.UserController.index/2","doc":"","ref":"TestWeb.UserController.html#index/2"},{"type":"function","title":"TestWeb.UserController.new/2","doc":"","ref":"TestWeb.UserController.html#new/2"},{"type":"function","title":"TestWeb.UserController.show/2","doc":"","ref":"TestWeb.UserController.html#show/2"},{"type":"function","title":"TestWeb.UserController.update/2","doc":"","ref":"TestWeb.UserController.html#update/2"},{"type":"type","title":"TestWeb.UserController.conn/0","doc":"","ref":"TestWeb.UserController.html#t:conn/0"},{"type":"behaviour","title":"TestWeb.UserFormattedTable","doc":"User table","ref":"TestWeb.UserFormattedTable.html"},{"type":"function","title":"TestWeb.UserFormattedTable.build_table/1","doc":"Convenience helper so LiveView doesn't have to be called directly","ref":"TestWeb.UserFormattedTable.html#build_table/1"},{"type":"function","title":"Example - TestWeb.UserFormattedTable.build_table/1","doc":"```\n<%= YourAppWeb.Live.Site.live_table(@conn, query: @query) %>\n```","ref":"TestWeb.UserFormattedTable.html#build_table/1-example"},{"type":"function","title":"TestWeb.UserFormattedTable.do_search/2","doc":"","ref":"TestWeb.UserFormattedTable.html#do_search/2"},{"type":"function","title":"TestWeb.UserFormattedTable.format/1","doc":"","ref":"TestWeb.UserFormattedTable.html#format/1"},{"type":"function","title":"TestWeb.UserFormattedTable.format/2","doc":"","ref":"TestWeb.UserFormattedTable.html#format/2"},{"type":"function","title":"TestWeb.UserFormattedTable.handle_event/3","doc":"Typing into the search box... searches. Crazy, right?","ref":"TestWeb.UserFormattedTable.html#handle_event/3"},{"type":"function","title":"TestWeb.UserFormattedTable.handle_info/2","doc":"Refresh periodically grabs new records from the database","ref":"TestWeb.UserFormattedTable.html#handle_info/2"},{"type":"function","title":"TestWeb.UserFormattedTable.live_table/2","doc":"","ref":"TestWeb.UserFormattedTable.html#live_table/2"},{"type":"function","title":"TestWeb.UserFormattedTable.mount/3","doc":"Initial setup on page load","ref":"TestWeb.UserFormattedTable.html#mount/3"},{"type":"function","title":"TestWeb.UserFormattedTable.name_backwards/2","doc":"","ref":"TestWeb.UserFormattedTable.html#name_backwards/2"},{"type":"function","title":"TestWeb.UserFormattedTable.render/1","doc":"","ref":"TestWeb.UserFormattedTable.html#render/1"},{"type":"callback","title":"TestWeb.UserFormattedTable.render/1","doc":"","ref":"TestWeb.UserFormattedTable.html#c:render/1"},{"type":"type","title":"TestWeb.UserFormattedTable.socket/0","doc":"","ref":"TestWeb.UserFormattedTable.html#t:socket/0"},{"type":"behaviour","title":"TestWeb.UserTable","doc":"User table","ref":"TestWeb.UserTable.html"},{"type":"function","title":"TestWeb.UserTable.build_table/1","doc":"Convenience helper so LiveView doesn't have to be called directly","ref":"TestWeb.UserTable.html#build_table/1"},{"type":"function","title":"Example - TestWeb.UserTable.build_table/1","doc":"```\n<%= YourAppWeb.Live.Site.live_table(@conn, query: @query) %>\n```","ref":"TestWeb.UserTable.html#build_table/1-example"},{"type":"function","title":"TestWeb.UserTable.do_search/2","doc":"","ref":"TestWeb.UserTable.html#do_search/2"},{"type":"function","title":"TestWeb.UserTable.handle_event/3","doc":"Typing into the search box... searches. Crazy, right?","ref":"TestWeb.UserTable.html#handle_event/3"},{"type":"function","title":"TestWeb.UserTable.handle_info/2","doc":"Refresh periodically grabs new records from the database","ref":"TestWeb.UserTable.html#handle_info/2"},{"type":"function","title":"TestWeb.UserTable.live_table/2","doc":"","ref":"TestWeb.UserTable.html#live_table/2"},{"type":"function","title":"TestWeb.UserTable.mount/3","doc":"Initial setup on page load","ref":"TestWeb.UserTable.html#mount/3"},{"type":"function","title":"TestWeb.UserTable.name_backwards/2","doc":"","ref":"TestWeb.UserTable.html#name_backwards/2"},{"type":"function","title":"TestWeb.UserTable.render/1","doc":"","ref":"TestWeb.UserTable.html#render/1"},{"type":"callback","title":"TestWeb.UserTable.render/1","doc":"","ref":"TestWeb.UserTable.html#c:render/1"},{"type":"type","title":"TestWeb.UserTable.socket/0","doc":"","ref":"TestWeb.UserTable.html#t:socket/0"},{"type":"exception","title":"Exzeitable.Params.ParameterError","doc":"An exception for missing or bad parameters","ref":"Exzeitable.Params.ParameterError.html"},{"type":"function","title":"Exzeitable.Params.ParameterError.message/1","doc":"Sets the correct message based on the missing parameter","ref":"Exzeitable.Params.ParameterError.html#message/1"},{"type":"extras","title":"Exzeitable","doc":"# Exzeitable\n\n[![Build Status](https://github.com/alanvardy/exzeitable/workflows/Coveralls/badge.svg)](https://github.com/alanvardy/exzeitable) [![Build Status](https://github.com/alanvardy/exzeitable/workflows/Dialyzer/badge.svg)](https://github.com/alanvardy/exzeitable) [![Build Status](https://github.com/alanvardy/exzeitable/workflows/Cypress/badge.svg)](https://github.com/alanvardy/exzeitable) [![Build Status](https://github.com/alanvardy/exzeitable/workflows/Credo/badge.svg)](https://github.com/alanvardy/exzeitable)[![Build Status](https://github.com/alanvardy/exzeitable/workflows/Doctor/badge.svg)](https://github.com/alanvardy/exzeitable) [![codecov](https://codecov.io/gh/alanvardy/exzeitable/branch/main/graph/badge.svg?token=P3O42SF7VJ)](https://codecov.io/gh/alanvardy/exzeitable)[![hex.pm](http://img.shields.io/hexpm/v/exzeitable.svg?style=flat)](https://hex.pm/packages/exzeitable)\n\nDynamic, live updating data tables generated with just a database query and a module. Ideal for quickly adding CRUD interfaces on an admin backend.\n\nFeatures:\n\n- Full-text search\n- Sorting\n- Periodic refresh\n- Bootstrap friendly and easily configured for other CSS frameworks.\n- Customizable everything (and if something isn't, open an issue!)\n- Powered by Phoenix LiveView and Postgres.\n\nFind the documentation at [https://hexdocs.pm/exzeitable](https://hexdocs.pm/exzeitable).","ref":"README.md.html"},{"type":"extras","title":"Video - Exzeitable","doc":"[![Watch the video](https://img.youtube.com/vi/GI1ryv0fcfs/0.jpg)](https://www.youtube.com/watch?v=GI1ryv0fcfs)\n\n- [Exzeitable](#exzeitable)\n  - [Video](#video)\n  - [Getting Started](#getting-started)\n    - [Dependencies](#dependencies)\n    - [Migration](#migration)\n    - [Module](#module)\n    - [Controller](#controller)\n    - [Template](#template)\n  - [Customizing your table](#customizing-your-table)\n    - [Required module/template options](#required-moduletemplate-options)\n    - [Optional module/template options](#optional-moduletemplate-options)\n    - [Field options](#field-options)\n    - [Module/template options for nested routes](#moduletemplate-options-for-nested-routes)\n    - [CSS](#css)\n  - [Contributing](#contributing)\n    - [Opening Issues and Pull Requests](#opening-issues-and-pull-requests)\n    - [Getting set up](#getting-set-up)","ref":"README.md.html#video"},{"type":"extras","title":"Getting Started - Exzeitable","doc":"See the [Exzeitable video on ElixirCasts](https://elixircasts.io/exzeitable) for a walkthrough.","ref":"README.md.html#getting-started"},{"type":"extras","title":"Dependencies - Exzeitable","doc":"This package requires a Postgres database, Phoenix, and Phoenix LiveView.\n\nAdd [Exzeitable](https://github.com/alanvardy/exzeitable) and [Phoenix Live View](https://github.com/phoenixframework/phoenix_live_view) to your list of dependencies in `mix.exs`.\n\n```elixir\ndef deps do\n  [\n    {:exzeitable, \"~> 0.6\"},\n  ]\nend\n```","ref":"README.md.html#dependencies"},{"type":"extras","title":"Migration - Exzeitable","doc":"Search requires the `pg_trgm` extension for Postgres.\n\nGenerate a new migration file and migrate to add it to Postgres.\n\n```bash\nmix exzeitable.gen.migration\nmix ecto.migrate\n```","ref":"README.md.html#migration"},{"type":"extras","title":"Module - Exzeitable","doc":"Add the boilerplate to a new module.\n\n```elixir\ndefmodule YourAppWeb.Live.File do\n  @moduledoc \"User's File table\"\n  alias YourAppWeb.Router.Helpers, as: Routes\n  import Ecto.Query\n\n  use Exzeitable,\n    # Required\n    repo: YourApp.Repo,\n    routes: Routes,\n    path: :file_path,\n    action_buttons: [:show, :edit, :custom_button],\n    query: from(f in File),\n    fields: [\n      image: [virtual: true],\n      title: [hidden: true],\n      description: [hidden: true],\n    ],\n    \n    # Optional\n    debounce: 300\n\n  # The callback that renders your table\n  def render(assigns), do: ~H\"<%= build_table(assigns) %>\"\n\n  # Field functions, called when virtual: true or function: true\n  def image(socket, file) do\n    img_tag(file.url, class: \"w-100\")\n    |> link(to: Routes.file_path(socket, :show, file))\n  end\nend\n```\n\nWe can add options to both the module (as seen above) and the template (As seen below). Template options overwrite module options.","ref":"README.md.html#module"},{"type":"extras","title":"Controller - Exzeitable","doc":"Controllers are an excellent place to define the base query that forms the default data of the table. Then, everything the table does is with a subset of this data.\n\n```elixir\nquery = from(f in Files)\nrender(conn, \"index.html\", query: query)\n```","ref":"README.md.html#controller"},{"type":"extras","title":"Template - Exzeitable","doc":"Call the table from your template\n\n```elixir\n  My Awesome Files  \n<%= YourAppWeb.Live.File.live_table(@conn, query: @query, action_buttons: [:show, :edit], assigns: %{user_id: @current_user.id}) %>\n```\n\nNote that if you are navigating to the live table using [Phoenix LiveView live_session/3](https://hexdocs.pm/phoenix_live_view/Phoenix.LiveView.Router.html#live_session/3) the opts in live_table/3 will not be utilized, and only the module options will apply.","ref":"README.md.html#template"},{"type":"extras","title":"Customizing your table - Exzeitable","doc":"","ref":"README.md.html#customizing-your-table"},{"type":"extras","title":"Required module/template options - Exzeitable","doc":"- `:repo` The module for your repository. Example: `YourApp.Repo`\n- `:routes` Your route module. Example: `YourAppWeb.Router.Helpers`\n- `:path` The base path for your resource. Example: `:site_path`\n- `:fields` A keyword list where the atom is the Ecto field and the value is a keyword list of options. Example: `metadata: [label: \"Additional Information\"]`\n- `:query` An Ecto.Query struct, the part before you give it to the Repo. Example: `from(s in Site, preload: [:users])`","ref":"README.md.html#required-module-template-options"},{"type":"extras","title":"Optional module/template options - Exzeitable","doc":"- `action_buttons: [:new, :edit, :show, :delete]` A list of atoms representing action buttons available for the user to use. Omitting an atom does not affect authorization, as the routes will still be available.\n- `per_page: 20` Integer representing the number of entries per page.\n- `debounce: 300` Sets how many milliseconds between responding to user input on the search field.\n- `refresh: false` Re-queries the database every x milliseconds, defaults to false (disabled).\n- `disable_hide: false` Disable show/hide functionality for columns, including not showing the buttons.\n- `pagination: [:top, :bottom]` Whether to show the pagination above and below\n- `text: Exzeitable.Text.Default` The translation that appears on the table, defaults to English.\n- `assigns: %{}` Passes additional assigns to socket.assigns. Keep your payload small!\n- `query_modifier: {MyModule, :my_function}` Passes the query to MyModule.my_function/2, where query can then be dynamically altered before being returned. Arguments are the query, and the `Exzeitable.Params` struct, which is how Exzeitable stores state. Return value is the query.\n- `html_classes` Allows the user to add additional HTML classes to elements. Is a list of 2-element tuples where the first element is a string representing the default class (or classes) and the second element is a string representing the classes to be added. I.e. if the default class is `exz-pagination-ul` then you can append `p-5` to it by adding `html_classes: [{\"exz-pagination-ul\", \"p-5\"}]`. This can make styling the table with tailwind or bootstrap much easier.\n\n```elixir\ndefmodule MyApp.MyModule do\n  def my_function(query, _state) do\n     # Make your modifications and return the new query\n    query\n  end\nend\n```","ref":"README.md.html#optional-module-template-options"},{"type":"extras","title":"Field options - Exzeitable","doc":"Under the fields key, you can define a keyword list of atoms with keyword values. The map holds the options for that field. All of these options are optional.\n\n```elixir\nfields: [\n          name: [function: true],\n          age: [order: false],\n          metadata: [label: \"Additional Information\", virtual: true, hidden: true],\n        ]\n```\n\nThe following field options are available (with their defaults):\n\n- `label: nil` Set a custom string value for the column heading\n- `function: false` Pass (socket, entry) to a function with the same name as the field\n- `hidden: false` Hide the column by default (user can click show button to reveal)\n- `search: true` Whether to include the column in search results. See the important note below.\n- `order: true` Do not allow the column to be sorted (hide the sort button)\n- `formatter: {Exzeitable.HTML.Format, :format}` Specifies a formatter function that will be applied to the column content when formatting. The formatter can be specified as either `{Mod, fun}` or `{Mod, fun, args}` (The function will have the original content prepended to the list of `args`). The default formatter passes through the data without modification.\n- `virtual: false` This is shorthand for `[function: true, search: false, order: false]` and will override those settings. Virtual fields are for creating fields that are not database-backed.\n\n**IMPORTANT NOTE**: Search uses [ts_vector](https://www.postgresql.org/docs/10/datatype-textsearch.html), which is performed by Postgres inside the database on string fields. This means that you cannot search fields that are _not_ string type (i.e. integer, datetime, associations, virtual fields). Make sure to set `search: false` or `virtual: true` on such fields.","ref":"README.md.html#field-options"},{"type":"extras","title":"Module/template options for nested routes - Exzeitable","doc":"Needed to build links where more than one struct is needed, i.e. `link(\"Show Post\", to: Routes.user_post_path(@conn, :show, @user, @post))`\n\n [The official docs](https://hexdocs.pm/phoenix/routing.html#nested-resources) if you would like to learn more.\n\nTo define `belongs_to`, you must also define `parent` (and vice versa).\n\nContinuing the example of users and posts:\n\n```elixir\nresources \"/users\", UserController do\n  resources \"/posts\", PostController\nend\n```\n\nThe users Exzeitable do not need the two options below, but the posts Exzeitable does. Because all of its routes are different. We will need the following to make the posts Exzeitable work:\n\n- `belongs_to: :user`\n- `parent: @user`\n\nMake sure that you include the `:user_id` in your query.\n\nIn addition, you will need to pass the parent option in from the template.","ref":"README.md.html#module-template-options-for-nested-routes"},{"type":"extras","title":"CSS - Exzeitable","doc":"I have added generic classes and almost no CSS styling to make the table as CSS framework agnostic as possible, and thus a user of this library should be able to style the tables to their needs.\n\nI have included a Bootstrap SASS example in the [CSS Module](https://github.com/alanvardy/exzeitable/blob/main/CSS.md)","ref":"README.md.html#css"},{"type":"extras","title":"Contributing - Exzeitable","doc":"","ref":"README.md.html#contributing"},{"type":"extras","title":"Opening Issues and Pull Requests - Exzeitable","doc":"Suggestions, bug reports, and contributions are very welcome! However, please open an issue before starting on a pull request, as I would hate to have any of your efforts be in vain.","ref":"README.md.html#opening-issues-and-pull-requests"},{"type":"extras","title":"Getting set up - Exzeitable","doc":"This project uses the `asdf` version manager and `docker-compose`.\n\nIf you would like to contribute, **fork** the repo on GitHub and then head over\nto your terminal.\n\n```bash\n# Clone the project from your GitHub fork\ngit clone git@github.com:yourname/exzeitable.git\ncd exzeitable\n\n# Start postgres\ndocker-compose up -d\n\n# Install dependencies\nasdf install\nmix deps.get\n\n# Build assets, and run the test suite\nmix check\n```","ref":"README.md.html#getting-set-up"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"CHANGELOG.md.html"},{"type":"extras","title":"Unreleased - Changelog","doc":"","ref":"CHANGELOG.md.html#unreleased"},{"type":"extras","title":"v0.6.7 (2024-12-18) - Changelog","doc":"- Update to Phoenix LiveView 1.0","ref":"CHANGELOG.md.html#v0-6-7-2024-12-18"},{"type":"extras","title":"v0.6.6 (2024-07-30) - Changelog","doc":"- User can add additional classes to table elements","ref":"CHANGELOG.md.html#v0-6-6-2024-07-30"},{"type":"extras","title":"v0.6.5 (2024-06-18) - Changelog","doc":"- Add `:query_modifier` option to allow dynamic altering of queries\n- Update Elixir and Erlang versions\n- Update dependencies","ref":"CHANGELOG.md.html#v0-6-5-2024-06-18"},{"type":"extras","title":"v0.6.4 (2024-03-03) - Changelog","doc":"- Update Elixir and Erlang versions\n- Update dependencies","ref":"CHANGELOG.md.html#v0-6-4-2024-03-03"},{"type":"extras","title":"v0.6.3 (2023-09-17) - Changelog","doc":"- Dependency updates and test fixes only","ref":"CHANGELOG.md.html#v0-6-3-2023-09-17"},{"type":"extras","title":"v0.6.2 (2023-04-06) - Changelog","doc":"- Re-release to fix versioning issue","ref":"CHANGELOG.md.html#v0-6-2-2023-04-06"},{"type":"extras","title":"v0.6.1 (2023-04-06) - Changelog","doc":"- Fix issue with adding action buttons to table\n- Update to Phoenix 1.7","ref":"CHANGELOG.md.html#v0-6-1-2023-04-06"},{"type":"extras","title":"v0.6.0 (2022-09-23) - Changelog","doc":"- Make Exzeitable compatible with Phoenix LiveView 0.18","ref":"CHANGELOG.md.html#v0-6-0-2022-09-23"},{"type":"extras","title":"v0.5.6 (2022-07-23) - Changelog","doc":"- Make tooling dependencies test only\n- Remove Phoenix Live Dashboard dependency","ref":"CHANGELOG.md.html#v0-5-6-2022-07-23"},{"type":"extras","title":"v0.5.5 (2022-07-23) - Changelog","doc":"- Bug fix for default formatter. Previously, it would attempt to_string on all values passing through which breaks `:safe` tuples.\n- Support live routes\n- Increase test coverage\n- Fix CodeCov badge link\n- Add BlitzCredoChecks\n- Remove `:gettext` from `:compilers` in `mix.exs` as it is no longer required there\n- Add additional dialyzer flags for OTP 25","ref":"CHANGELOG.md.html#v0-5-5-2022-07-23"},{"type":"extras","title":"v0.5.4 (2022-04-30) - Changelog","doc":"- Add `mix exzeitable.gen.migration` task for adding pg_trgm extension migration file\n- General refactoring\n- Added Params struct for representing the state\n- Fix remaining `use Mix.Config`\n- Cleanup stray files\n- Add Doctor","ref":"CHANGELOG.md.html#v0-5-4-2022-04-30"},{"type":"extras","title":"v0.5.3 (2022-03-30) - Changelog","doc":"- Add formatter to field options\n- Update Erlang to 24.2\n- Update Elixir to 1.13.3\n- Add a link to the Elixir Casts video in Readme\n- Update Postgres to 14.2\n- General refactoring","ref":"CHANGELOG.md.html#v0-5-3-2022-03-30"},{"type":"extras","title":"v0.5.2 (2022-01-08) - Changelog","doc":"- Update dependencies\n- Update Credo and resolve Credo warnings","ref":"CHANGELOG.md.html#v0-5-2-2022-01-08"},{"type":"extras","title":"v0.5.1 (2021-11-14) - Changelog","doc":"- Re-add dependabot\n- Update Elixir dependencies\n- Add publish checklist\n- Change `eex` templates to `heex`\n- Add CodeCov","ref":"CHANGELOG.md.html#v0-5-1-2021-11-14"},{"type":"extras","title":"v0.5.0 (2021-10-25) - Changelog","doc":"- Update to Phoenix 1.6 and Phoenix LiveView 0.16\n- Update Elixir and Erlang versions\n- Rip out Webpack and fire it into the sun\n- Capitalize word","ref":"CHANGELOG.md.html#v0-5-0-2021-10-25"},{"type":"extras","title":"v0.4.6 (2021-08-21) - Changelog","doc":"- Update CI configuration\n- Tighten up typespecs\n- Update docs\n- Update Elixir dependencies\n- Update JavaScript dependencies","ref":"CHANGELOG.md.html#v0-4-6-2021-08-21"},{"type":"extras","title":"v0.4.5 (2021-04-04) - Changelog","doc":"- Update dependencies\n- Fix typos in moduledocs (Thank you `@clayscode`)","ref":"CHANGELOG.md.html#v0-4-5-2021-04-04"},{"type":"extras","title":"v0.4.4 (2021-01-16) - Changelog","doc":"- Update dependencies\n- Switched out UglifyJS for TerserJS","ref":"CHANGELOG.md.html#v0-4-4-2021-01-16"},{"type":"extras","title":"v0.4.3 - Changelog","doc":"- Remove Dependabot","ref":"CHANGELOG.md.html#v0-4-3"},{"type":"extras","title":"v0.4.2 (2020-08-31) - Changelog","doc":"- Support searching across multiple columns (thank you `@greg-rychlewski`)\n- Use regex for slightly improved search speed (thank you again `@greg-rychlewski`)\n- Remove cypress-ci as its custom functionality is not being used on CI\n- Update JavaScript assets\n- Improve install instructions\n- Provide docker-compose.yml for Postgres","ref":"CHANGELOG.md.html#v0-4-2-2020-08-31"},{"type":"extras","title":"v0.4.1 (2020-07-10) - Changelog","doc":"- Bugfix: Added custom text for \"Actions\" (was missed in the last release)\n- Improved the test suite so that `mix check` runs `credo` before the other tests\n- Improve the README","ref":"CHANGELOG.md.html#v0-4-1-2020-07-10"},{"type":"extras","title":"v0.4.0 (2020-07-04) - Changelog","doc":"- No breaking changes to API\n- Feature: Added custom text functionality via the `:text` keyword\n- Feature: Added ability to disable hide functionality\n- Feature: Added ability to hide pagination\n- Various dependency updates\n- Refactored a bunch of things that were bugging me","ref":"CHANGELOG.md.html#v0-4-0-2020-07-04"},{"type":"extras","title":"v0.3.3 (2020-06-19) - Changelog","doc":"- I made no breaking changes to the API, only to dependency requirements.\n- Feature: Add a refresh rate for re-querying database periodically\n- Update Elixir and Javascript dependencies.\n- Update Elixir to 1.10.3\n- Update Erlang to 22.3.4\n- Add MIT license\n- Did some coarse-level refactoring around function locations","ref":"CHANGELOG.md.html#v0-3-3-2020-06-19"},{"type":"extras","title":"v0.3.2 (2020-02-04) - Changelog","doc":"- Update Elixir and Javascript dependencies.\n- Add a route for tests.","ref":"CHANGELOG.md.html#v0-3-2-2020-02-04"},{"type":"extras","title":"v0.3.1 (2020-02-04) - Changelog","doc":"- Update to support Phoenix LiveView 0.6.0, removing the deprecated `mount/2` in favor of `mount/3`.","ref":"CHANGELOG.md.html#v0-3-1-2020-02-04"},{"type":"extras","title":"v0.3.0 (2020-01-18) - Changelog","doc":"- BREAKING CHANGES\n- Update to support Phoenix LiveView 0.5.x (breaking compatibility with previous versions)\n- Make sure to check the Phoenix LiveView [CHANGELOG](https://github.com/phoenixframework/phoenix_live_view/blob/master/CHANGELOG.md)","ref":"CHANGELOG.md.html#v0-3-0-2020-01-18"},{"type":"extras","title":"v0.2.8 (2020-01-13) - Changelog","doc":"- Use coalesce on all database columns to guard against NULL values","ref":"CHANGELOG.md.html#v0-2-8-2020-01-13"},{"type":"extras","title":"v0.2.7 (2019-12-18) - Changelog","doc":"- Dependency updates","ref":"CHANGELOG.md.html#v0-2-7-2019-12-18"},{"type":"extras","title":"v0.2.6 (2019-12-07) - Changelog","doc":"- Allow Phoenix LiveView 0.3 as well as 0.4","ref":"CHANGELOG.md.html#v0-2-6-2019-12-07"},{"type":"extras","title":"v0.2.5 (2019-12-03) - Changelog","doc":"- Added custom buttons, defined similarly to the custom fields\n- Added a behaviour for render/1 in the user-defined table module\n- Broke out `Pagination` and `ActionButton` modules from Exzeitable.HTML","ref":"CHANGELOG.md.html#v0-2-5-2019-12-03"},{"type":"extras","title":"v0.2.4 (2019-10-31) - Changelog","doc":"- Fix bug where order not removed when getting a count","ref":"CHANGELOG.md.html#v0-2-4-2019-10-31"},{"type":"extras","title":"v0.2.3 (2019-10-21) - Changelog","doc":"- Smoosh `assigns` and `socket.assigns` together and deduplicate\n- Clear order_by before ordering query\n- Correct documentation","ref":"CHANGELOG.md.html#v0-2-3-2019-10-21"},{"type":"extras","title":"v0.2.2 (2019-10-20) - Changelog","doc":"- Add support for passing assigns through to custom field functions\n- Remove the actions column when no actions\n- Added a nothing found message when no content\n- Renamed CSS classes from .lt- to .exz-","ref":"CHANGELOG.md.html#v0-2-2-2019-10-20"},{"type":"extras","title":"v0.2.1 (2019-10-18) - Changelog","doc":"- Fixed a CSRF token error on delete actions","ref":"CHANGELOG.md.html#v0-2-1-2019-10-18"},{"type":"extras","title":"v0.2.0 (2019-10-12) - Changelog","doc":"- Rebuilt with Phoenix (originally was just a Mix project)\n- Added dev environment\n- Added acceptance tests with Cypress\n- Added additional unit tests","ref":"CHANGELOG.md.html#v0-2-0-2019-10-12"},{"type":"extras","title":"v0.1.2 (2019-10-11) - Changelog","doc":"- Added ability to show and hide 'show buttons' for columns\n- Disabled use of the enter key with the search box (created a CSRF error)\n- Added specs\n- Added documentation","ref":"CHANGELOG.md.html#v0-1-2-2019-10-11"},{"type":"extras","title":"v0.1.1 (2019-10-09) - Changelog","doc":"- Fix iOS touch issues\n- Add inch_ex\n- Minor documentation improvements","ref":"CHANGELOG.md.html#v0-1-1-2019-10-09"},{"type":"extras","title":"v0.1.0 (2019-10-03) - Changelog","doc":"- Initial release","ref":"CHANGELOG.md.html#v0-1-0-2019-10-03"},{"type":"extras","title":"CSS","doc":"# CSS  \n  \n  You will need to add styling for the form, I attempted to make the classes as unopinionated as possible.\n\n  Below is a SASS example for Bootstrap 4\n\n  ```css\n  // #############################\n  // ########### TABLE ###########\n  // #############################\n\n  // div around the table\n  .exz-table-wrapper {\n    @extend .table-responsive;\n  }\n\n  // the table\n  .exz-table {\n    @extend .table;\n\n    thead {\n      @extend .thead-dark;\n    }\n  }\n\n  // div around exz-pagination-div and exz-search-div\n  .exz-row {\n    @extend .row;\n  }\n\n  .exz-nothing-found {\n    @extend .text-center\n  }\n\n  // #############################\n  // ########### SEARCH ##########\n  // #############################\n\n  // div around the search box\n  .exz-search-wrapper {\n    @extend .col-xl-6;\n  }\n\n  //The search form (I don't need this)\n  // .exz-search-form {\n\n  // }\n\n  .exz-search-field {\n    @extend .form-control;\n    @extend .mb-1;\n  }\n\n  .exz-search-field-wrapper {\n    @extend .input-group;\n  }\n\n  .exz-counter-field {\n    @extend .input-group-text;\n  }\n\n  .exz-counter-field-wrapper {\n    @extend .input-group-append;\n    @extend .mb-1;\n  }\n\n  // #############################\n  // ######## PAGINATION #########\n  // #############################\n\n  // div around the pagination nav\n  .exz-pagination-wrapper {\n    @extend .col-xl-6;\n  }\n\n  // nav around pagination ul\n  .exz-pagination-nav {\n    @extend .mt-1;\n    @extend .mt-xl-0;\n  }\n\n  // ul around pagination li\n  .exz-pagination-ul {\n    @extend .pagination;\n    @extend .pagination-sm;\n  }\n\n  // li around pagination links\n  .exz-pagination-li {\n    @extend .page-item;\n  }\n\n  // li around pagination links when active\n  .exz-pagination-li-active {\n    @extend .page-item;\n    @extend .active;\n    color: white;\n  }\n\n  // li around pagination links when disabled\n  .exz-pagination-li-disabled {\n    @extend .page-item;\n    @extend .disabled;\n  }\n\n  // Base class for pagination link\n  .exz-pagination-a {\n    @extend .page-link;\n    @extend .text-center;\n    @extend .mt-1;\n  }\n\n  // Fixed width for pagination link with number\n  .exz-pagination-width {\n    width: 50px;\n  }\n\n  // #############################\n  // ####### Header Links ########\n  // #############################\n\n\n  // Hide link\n  .exz-hide-link {\n    @extend .mx-1;\n    @extend .small;\n    cursor: grabbing;\n  }\n\n  // Sort link\n  .exz-sort-link {\n    @extend .mx-1;\n    @extend .small;\n    cursor: grabbing;\n  }\n\n  // Buttons for showing hidden columns\n  .exz-show-button {\n    @extend .btn;\n    @extend .btn-sm;\n    @extend .btn-outline-secondary;\n    @extend .m-1;\n    cursor: grabbing;\n  }\n\n  // Buttons for showing hidden columns\n  .exz-info-button {\n    @extend .btn;\n    @extend .btn-sm;\n    @extend .btn-outline-info;\n    @extend .m-1;\n    cursor: grabbing;\n  }\n\n  // #############################\n  // ###### Action Buttons #######\n  // #############################\n\n  .exz-action-delete {\n    @extend .btn;\n    @extend .btn-sm;\n    @extend .my-1;\n    @extend .mr-1;\n    @extend .btn-outline-danger;\n  }\n\n  .exz-action-new {\n    @extend .btn;\n    @extend .btn-sm;\n    @extend .my-1;\n    @extend .mr-1;\n    @extend .btn-outline-primary;\n  }\n\n  .exz-action-show {\n    @extend .btn;\n    @extend .btn-sm;\n    @extend .my-1;\n    @extend .mr-1;\n    @extend .btn-outline-primary;\n  }\n\n  .exz-action-edit {\n    @extend .btn;\n    @extend .btn-sm;\n    @extend .my-1;\n    @extend .mr-1;\n    @extend .btn-outline-info;\n  }\n  ```","ref":"CSS.md.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}